/*
 * Created on 2005. 4. 20
 */
package org.manalith.manager;

import org.apache.log4j.Logger;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.manalith.db.HibernateUtil;
import org.manalith.resource.VisitorLog;

/**
 * @author setzer
 */
public class VisitorLogManager {
    private static VisitorLogManager manager;
    private static Logger logger = Logger.getLogger(VisitorLogManager.class);
    
    private VisitorLogManager(){
    }
    
    public static VisitorLogManager instance(){
        if(manager == null){
            manager = new VisitorLogManager();
        }
        return manager;
    }
    
    public void addLog(VisitorLog vLog){
        Session session = HibernateUtil.currentSession();
        Transaction tx = null;
        
        try{
	        tx = session.beginTransaction();
	        session.save(vLog);
	        tx.commit();
        }catch(HibernateException e){
            if(tx != null) tx.rollback();
            logger.error(e);
        }finally{
            HibernateUtil.closeSession();
        }
    }
}
