/*
 * Created on 2005. 4. 21
 */
package org.manalith.util.rss;

import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.apache.log4j.Logger;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;


/**
 * @author setzer
 */
public class RSSUtil {
    private static RSSUtil util = null;
    private static Logger logger = Logger.getLogger(RSSUtil.class);
    
    private RSSUtil(){
        
    }
    
    public static RSSUtil instance(){
        if(util == null){
            util = new RSSUtil();
        }
        
        return util;
    }
    
    public RSSObject parse(String url){
        return parse(url, "UTF-8");
    }
    
    public RSSObject parse(String url, String charset){
        //Fri, 22 Apr 2005 04:04:58 +0900
        SimpleDateFormat pubDateFormatter = new SimpleDateFormat("EEE, d MMM yyyy HH:mm:ss Z",Locale.US);
        //2005-04-21T18:22:22+09:00
        SimpleDateFormat dcDateFormatter = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss",Locale.US);
        //logger.error(dcDateFormatter.format(new Date()));
        /*
        HttpClient client = new HttpClient();
        HttpMethod method = null;
        String text = null;
        try {
            method = new GetMethod(url);
            int statusCode = client.executeMethod(method);
            text = method.getResponseBodyAsString();
        } catch (HttpException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } finally {
            method.releaseConnection();
        }
        */
        RSSObject ro = null;
        
        
        try {
            ro = new RSSObject();
            RSSChannelObject roc = null;
            List channels = new ArrayList();
            
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            DocumentBuilder domParser = null;
            domParser = factory.newDocumentBuilder();
            
            Document document = domParser.parse(url);
            
            Node rss = document.getDocumentElement();
            ro.setVersion(rss.getAttributes().getNamedItem("version").getNodeValue());
            
            NodeList nChannels = document.getElementsByTagName("channel");
            
            for(int i=0;i<nChannels.getLength();i++){
               roc = new RSSChannelObject();
               List items = new ArrayList();
               RSSChannelItemObject roci = null;
               
               NodeList nChannelValues = nChannels.item(i).getChildNodes();
               
               for(int x=0;x<nChannelValues.getLength();x++){
	               Node node = nChannelValues.item(x);
	               String name = node.getNodeName();
	               String value = node.getTextContent();
	               
		            if(name.equals("title")){
		                roc.setTitle(value);
		            }else if(name.equals("link")){
		                roc.setLink(value);
		            }else if(name.equals("language")){
		                roc.setLanguage(value);
		            }else if(name.equals("dc:language")){
		                roc.setLanguage(value);
		            }else if(name.equals("copyright")){
		                roc.setCopyright(value);
		            }else if(name.equals("pubDate")){
		                try{
                            roc.setPubDate(pubDateFormatter.parse(value));
                        }catch(ParseException e){
                            logger.error("parse fail : " + value);
                        }
		            }else if(name.equals("dc:date")){
		                try{
                            roc.setPubDate(dcDateFormatter.parse(value));
                        }catch(ParseException e){
                            logger.error("parse fail : " + value);
                        }
		            }else if(name.equals("generator")){
		                roc.setGenerator(value);
		            }else if(name.equals("item")){
		                NodeList nItemValues = node.getChildNodes();
	                   roci = new RSSChannelItemObject(); 
		                
		                for(int y=0;y<nItemValues.getLength();y++){
		                    Node itemValue = nItemValues.item(y);
		                 
		                    String iName = itemValue.getNodeName();
		                    String iValue = itemValue.getTextContent();
		                    
		                    if(iName.equals("title")){
		                        roci.setTitle(iValue);
		                    }else if(iName.equals("link")){
		                        roci.setLink(iValue);
		                    }else if(iName.equals("pubDate")){
		                        try{
		                            roci.setPubDate(pubDateFormatter.parse(iValue));
		                        }catch(ParseException e){
		                            logger.error("parse fail : " + iValue);
		                        }
		                    }else if(iName.equals("dc:date")){
		                        try{
		                            roci.setPubDate(dcDateFormatter.parse(iValue));
		                        }catch(ParseException e){
		                            logger.error("parse fail : " + iValue);
		                        }
		                    }else if(iName.equals("category")){
		                        roci.setCategory(iValue);
		                    }else if(iName.equals("description")){
		                        roci.setDescription(iValue);
		                    }
		                    
		                }
	                    items.add(roci);
		            }
               }
               roc.setItems(items);
               channels.add(roc);
	            ro.setChannels(channels);
            }
        } catch (ParserConfigurationException e) {
            e.printStackTrace();
        } catch (SAXException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        
        return ro;
    }
}
